<?php
namespace Teknisa\PLA\Modules\Prato\Controllers;


use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DataSource;
use Doctrine\DBAL\Connection;
use Zeedhi\Framework\DB\StoredProcedure\Param;
use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
class CalcularQuantidadeController {
    protected $crudService;
    protected $environment;
    protected $connection;
    protected $util;
    protected $nrlista;

    public function __construct($crudService,$environment,$connection,$util) {
        $this->crudService                          = $crudService;
        $this->environment                          = $environment;
        $this->connection                           = $connection;
        $this->util                                 = $util;
        
    }
    
   public function Calcular(DTO\Request $request, DTO\Response $response){
        try {
            $row = $request->getRow();
            $row['NRORG']= $this->environment->getNrOrg();
            $row['CDOPERADOR']=$this->environment->getCdOperador();
            $cdfiliserv = $this->getCdfiliserv($row);
            $this->nrlista = $this->util->insertLista($cdfiliserv);
            $row["NRLISTA"] = $this->nrlista;
		    $this->calcula_qtde_pessoa($row, $response);
		    $this->util->deleteLista($this->nrlista);


        } catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), 500));
        }
    }
      private function calcula_qtde_pessoa ($row, DTO\Response $response){
        try {
			$procedure = new StoredProcedure($this->connection, 'CALCULA_QTDE_PESSOA');
			$procedure->addParam(new Param('P_NRLISTA',         Param::PARAM_INPUT, $row['NRLISTA'], Param::PARAM_TYPE_STR));
			$procedure->addParam(new Param('P_CDOPERADOR',      Param::PARAM_INPUT, $row['CDOPERADOR'], Param::PARAM_TYPE_STR));
			$procedure->addParam(new Param('P_CDPRATOINI',      Param::PARAM_INPUT, $row['CDPRATOINI'], Param::PARAM_TYPE_STR));
			$procedure->addParam(new Param('P_CDPRATOFIM',      Param::PARAM_INPUT, $row['CDPRATOFIN'], Param::PARAM_TYPE_STR));
			$procedure->addParam(new Param('P_IDTIPOEXPORTACAO',Param::PARAM_INPUT, $row['IDTIPOEXPORTACAO'], Param::PARAM_TYPE_STR));
			$procedure->addParam(new Param('P_IDTIPORECEITA',   Param::PARAM_INPUT, $row['IDTIPORECEITA'], Param::PARAM_TYPE_STR));
			$procedure->addParam(new Param('P_VRQTDEPESSOA',   Param::PARAM_INPUT, $row['VRQTDEPESSOA'], Param::PARAM_TYPE_STR));
			$result = $procedure->execute();
        } catch (\Exception $e) {
           
            $response->setError(new Error($e->getMessage(), 500));
            // $response->addDataSet(new DataSet("msgError", $msg));
        }
    }
      private function getCdfiliserv($row) {
        if ($row["TODOSSERVICOS"] != "S") {
            return $row["CDFILISERV"];
        } else {
            $conditions = array(
                array(
                    "columnName" => "CDFILIAL",
                    "operator"   => '=',
                    "value"      => $row["TODOSUNIDADES"] == "S" ? "T" : implode("_", $row["NMFILIALSELECTMULTIPLE"])
                ),
                array(
                    "columnName" => "CDGRUPSERV",
                    "operator"   => '=',
                    "value"      => "T"
                ),
                array(
                    "columnName" => "CDOPERADOR",
                    "operator"   => '=',
                    "value"      => $row['CDOPERADOR']
                ),
                array(
                    "columnName" => "CDGRUPFILI",
                    "operator"   => '=',
                    "value"      => isset($row["CDGRUPFILI"]) && !empty($row["CDGRUPFILI"]) ? $row['CDGRUPFILI'] : "T"
                )
            );
            $dataSet = $this->crudService->getFilteredDataSet("servico_operador_filgrupfili_filial_grupserv", $conditions);
            $rows = $dataSet->getRows();
            $cdfiliserv = array();
            foreach ($rows as $row) {
                array_push($cdfiliserv, $row["CHAVE"]);
            }
            return $cdfiliserv;
        }
    }
   
}